<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional;


interface Predicate
{
    public function __invoke(...$args): bool;

    public function not(): Predicate;

    public function and(...$predicate): Predicate;
    public function or(...$predicate): Predicate;
}